function init()
    shapes = setmetatable({},{
        __index = function(t, k)
            local shape = FindShape(k)
            rawset(t, k, shape)
            return shape
        end
    })

    lights = setmetatable({},{
        __index = function(m, n)
            local light = FindLight(n)
            rawset(m, n, light)
            return light
        end
    })

    dl = FindJoint("dl")
    dl1 = FindJoint("dl1")
    dl2 = FindJoint("dl2")
    dl3 = FindJoint("dl3")
    dl4 = FindJoint("dl4")
    dl5 = FindJoint("dl5")
    dr = FindJoint("dr")
    dr1 = FindJoint("dr1")
    dr2 = FindJoint("dr2")
    dr3 = FindJoint("dr3")
	local vehicle = FindVehicle("ambulancia")

    limmdl, limxdl = GetJointLimits(dl)
	loop = LoadLoop("MOD/ambu/police.ogg")
	loop2 = LoadLoop("MOD/ambu/police2.ogg")
	loop4 = LoadLoop("MOD/ambu/police3.ogg")
	loop3 = LoadLoop("MOD/ambu/horn.ogg")
    frame = math.random(0, 60)
    lightOn = false
    mlo = false
    hlo = false
    note = false
    tl = false
    tr = false
    warning = false
    flash = false
    temp = false
    adt = false
    elight = false
    elight2 = false
    siren = false
    siren2 = false
    di = 0
    es = 0
    fa1 = 0 
    fa2 = 0
    fa3 = 0 
    fa4 = 0
    am1 = 0
    am2 = 0
    am3 = 0
    am4 = 0
    am5 = 0
    am6 = 0
    am7 = 0
    am8 = 0
    am9 = 0
end

function tick(dt)
	lightrigger = FindTrigger("lighttrigger")
		v = FindVehicle("ambu")
	local t = Transform(GetVehicleTransform(v).pos, Vec(0,1,0))
	SetTriggerTransform(lightrigger, t)


if IsPointInTrigger(lightrigger, GetPlayerPos()) then
    if GetBool("game.player.usevehicle") then
        dLocked = true
        if note then
        else
            SetString("hud.notification", "'J'\t \t \t Low Beam \n 'K'\t \t \t High-beam \n '  ,  (<)' & '  .  (>)'\t \t \t Blinkers \n 'U' \t \t \t Warning Lights \n 'L' \t \t \t Light Signal \n 'H' \t \t \t Fog Light \n '1/2' \t \t \t Siren \n 'I/O' \t \t \t Emergence Lights \n 'G' \t \t \t Horn")
            note = true
        end
	else
        dLocked = false
    end

    if dLocked then
        if GetJointMovement(dl) > limmdl + 0.5 then
            SetJointMotor(dl, 1)
        else
            SetJointMotor(dl, 0)
        end
        if GetJointMovement(dl1) > limmdl + 0.5 then
            SetJointMotor(dl1, 2)
        else
            SetJointMotor(dl1, 0)
        end
        if GetJointMovement(dl2) > limmdl + 0.5 then
            SetJointMotor(dl2, 2)
        else
            SetJointMotor(dl2, 0)
        end
        if GetJointMovement(dl3) > limmdl + 0.5 then
            SetJointMotor(dl3, 2)
        else
            SetJointMotor(dl3, 0)
        end
        if GetJointMovement(dl4) > limmdl + 0.5 then
            SetJointMotor(dl4, 2)
        else
            SetJointMotor(dl4, 0)
        end
        if GetJointMovement(dl5) > limmdl + 0.5 then
            SetJointMotor(dl5, 2)
        else
            SetJointMotor(dl5, 0)
        end
        if GetJointMovement(dr) > limmdl + 0.5 then
            SetJointMotor(dr, 2)
        else
            SetJointMotor(dr, 0)
        end
        if GetJointMovement(dr1) > limmdl + 0.5 then
            SetJointMotor(dr1, 2)
        else
            SetJointMotor(dr1, 0)
        end
        if GetJointMovement(dr2) > limmdl + 0.5 then
            SetJointMotor(dr2, 2)
        else
            SetJointMotor(dr2, 0)
        end
        if GetJointMovement(dr3) > limmdl + 0.5 then
            SetJointMotor(dr3, 2)
        else
            SetJointMotor(dr3, 0)
        end
    else
        SetJointMotor(dl, 0, 0)
        SetJointMotor(dl1, 0, 0)
        SetJointMotor(dl2, 0, 0)
        SetJointMotor(dl3, 0, 0)
        SetJointMotor(dl4, 0, 0)
        SetJointMotor(dl5, 0, 0)
        SetJointMotor(dr, 0, 0)
        SetJointMotor(dr1, 0, 0)
        SetJointMotor(dr2, 0, 0)
        SetJointMotor(dr3, 0, 0)
    end

    if GetBool("game.player.useVehicle") and InputPressed("j") then
        mlo = not mlo
    end

    if GetBool("game.player.useVehicle") and InputPressed("k") then
        hlo = not hlo
    end


    if GetBool("game.player.useVehicle") and InputPressed(",") then
        tl = not tl
        tr = false
        warning = false
        to = GetTime()
    end

    if GetBool("game.player.useVehicle") and InputPressed(".") then
        tr = not tr
        tl = false
        warning = false
        to = GetTime()
    end

    if GetBool("game.player.useVehicle") and InputPressed("u") then
        warning = not warning
        tl = false
        tr = false
        to = GetTime()
    end



    if GetBool("game.player.useVehicle") and InputDown("l") then
        flash = true
    else
        flash = false
    end


    if GetBool("game.player.useVehicle") and InputDown("g") then
	PlayLoop(loop3,GetVehicleTransform(v).pos, 0.8)
    end
    if GetBool("game.player.useVehicle") and InputPressed("i") then
        elight = not elight
        elight2 = false
        elight3 = false
        to = GetTime()
    end
    if GetBool("game.player.useVehicle") and InputPressed("o") then
        elight2 = not elight2
        elight = false
        elight3 = false
    end
    if GetBool("game.player.useVehicle") and InputPressed("1") then
        siren = not siren
        siren2 = false
    end
    if GetBool("game.player.useVehicle") and InputPressed("2") then
        siren2 = not siren2
        siren = false
	end
end




if elight or elight2 then
	if siren then
	PlayLoop(loop,GetVehicleTransform(v).pos, 0.8)
	else
	if siren2 then
	PlayLoop(loop2,GetVehicleTransform(v).pos, 0.8)
	end
end
end

    if tl or tr or warning then
        a = math.cos((GetTime()-to)*9)
        if a >= 0 then
            tli = 1
        else
            tli = 0.0001
        end



        if warning then
            SetShapeEmissiveScale(shapes.tlfl2, tli)
            SetShapeEmissiveScale(shapes.tlbl2, tli)
            SetShapeEmissiveScale(shapes.tlfr2, tli)
            SetShapeEmissiveScale(shapes.tlbr2, tli)
        SetLightIntensity(lights.tlflp2, tli)
        SetLightIntensity(lights.tlblp2, tli)
        SetLightIntensity(lights.tlfrp2, tli)
        SetLightIntensity(lights.tlbrp2, tli)



        else
            if tl then
                SetShapeEmissiveScale(shapes.tlfl2, tli)
                SetShapeEmissiveScale(shapes.tlbl2, tli)
                SetShapeEmissiveScale(shapes.tlfr2, 0)
                SetShapeEmissiveScale(shapes.tlbr2, 0)
        SetLightIntensity(lights.tlflp2, tli)
        SetLightIntensity(lights.tlblp2, tli)
        SetLightIntensity(lights.tlfrp2, 0)
        SetLightIntensity(lights.tlbrp2, 0)

            elseif tr then
                SetShapeEmissiveScale(shapes.tlfr2, tli)
                SetShapeEmissiveScale(shapes.tlbr2, tli)
                SetShapeEmissiveScale(shapes.tlfl2, 0)
                SetShapeEmissiveScale(shapes.tlbl2, 0)
        SetLightIntensity(lights.tlflp2, 0)
        SetLightIntensity(lights.tlblp2, 0)
        SetLightIntensity(lights.tlfrp2, tli)
        SetLightIntensity(lights.tlbrp2, tli)

            else
                SetShapeEmissiveScale(shapes.tlfl2, 0)
                SetShapeEmissiveScale(shapes.tlbl2, 0)
                SetShapeEmissiveScale(shapes.tlfr2, 0)
                SetShapeEmissiveScale(shapes.tlbr2, 0)
        SetLightIntensity(lights.tlflp2, 0)
        SetLightIntensity(lights.tlblp2, 0)
        SetLightIntensity(lights.tlfrp2, 0)
        SetLightIntensity(lights.tlbrp2, 0)

         end
      end
    else
        SetShapeEmissiveScale(shapes.tlfl2, 0)
        SetShapeEmissiveScale(shapes.tlbl2, 0)
        SetShapeEmissiveScale(shapes.tlfr2, 0)
        SetShapeEmissiveScale(shapes.tlbr2, 0)
        SetLightIntensity(lights.tlflp2, 0)
        SetLightIntensity(lights.tlblp2, 0)
        SetLightIntensity(lights.tlfrp2, 0)
        SetLightIntensity(lights.tlbrp2, 0)

    end
end


    function update(dt)
	frame = frame + 1

    if flash then
        SetLightIntensity(lights.lflmr2, 100)
        SetLightIntensity(lights.lflml2, 100)
        SetLightIntensity(lights.lfrmr2, 100)
        SetLightIntensity(lights.lfrml2, 100)
            SetLightIntensity(lights.lflmrt2, 0.2)
            SetLightIntensity(lights.lflmlt2, 0.2)
            SetLightIntensity(lights.lfrmrt2, 0.2)
            SetLightIntensity(lights.lfrmlt2, 0.2)
    else


        if mlo then
            SetShapeEmissiveScale(shapes.lflm2, 1)
            SetShapeEmissiveScale(shapes.lfrm2, 1)
            SetShapeEmissiveScale(shapes.lflmt2, 1)
            SetShapeEmissiveScale(shapes.lfrmt2, 1)
        else
            SetShapeEmissiveScale(shapes.lflm2, 0)
            SetShapeEmissiveScale(shapes.lfrm2, 0)
            SetShapeEmissiveScale(shapes.lflmt2, 0)
            SetShapeEmissiveScale(shapes.lfrmt2, 0)
        end

        if mlo and hlo then
            SetLightIntensity(lights.lflmr2, 100)
            SetLightIntensity(lights.lflml2, 100)
            SetLightIntensity(lights.lfrmr2, 100)
            SetLightIntensity(lights.lfrml2, 100)
            SetLightIntensity(lights.lflmrt2, 0.2)
            SetLightIntensity(lights.lflmlt2, 0.2)
            SetLightIntensity(lights.lfrmrt2, 0.2)
            SetLightIntensity(lights.lfrmlt2, 0.2)
        elseif mlo then
            SetLightIntensity(lights.lflmr2, 10)
            SetLightIntensity(lights.lflml2, 10)
            SetLightIntensity(lights.lfrmr2, 10)
            SetLightIntensity(lights.lfrml2, 10)
            SetLightIntensity(lights.lflmrt2, 0.2)
            SetLightIntensity(lights.lflmlt2, 0.2)
            SetLightIntensity(lights.lfrmrt2, 0.2)
            SetLightIntensity(lights.lfrmlt2, 0.2)
        else
            SetLightIntensity(lights.lflmr2, 0.0001)
            SetLightIntensity(lights.lflml2, 0.0001)
            SetLightIntensity(lights.lfrmr2, 0.0001)
            SetLightIntensity(lights.lfrml2, 0.0001)
            SetLightIntensity(lights.lflmrt2, 0.0001)
            SetLightIntensity(lights.lflmlt2, 0.0001)
            SetLightIntensity(lights.lfrmrt2, 0.0001)
            SetLightIntensity(lights.lfrmlt2, 0.0001)
        end
    end

	if elight then
			local period = 60
			local t = frame%period

			--toplights
			if t == 0 then 	am1 = 1 end
			if t == 10 then am1 = 0 end
			if t == 5 then am2 = 1 end
			if t == 15 then am2 = 0 end
			if t == 10 then am3 = 1 end
			if t == 20 then am3 = 0 end
			if t == 15 then am4 = 1 end
			if t == 25 then am4 = 0 end
			if t == 20 then am5 = 1 end
			if t == 15 then am6 = 1 end
			if t == 25 then am6 = 0 end
			if t == 10 then am7 = 1 end
			if t == 20 then am7 = 0 end
			if t == 5 then am8 = 1 end
			if t == 15 then am8 = 0 end
			if t == 0 then am9 = 1 end
			if t == 10 then am9 = 0 end

			if t == 45 then am1 = 1 end
			if t == 55 then am1 = 0 end
			if t == 40 then am2 = 1 end
			if t == 50 then am2 = 0 end
			if t == 35 then am3 = 1 end
			if t == 45 then am3 = 0 end
			if t == 30 then am4 = 1 end
			if t == 40 then am4 = 0 end
			if t == 35 then am5 = 0 end
			if t == 30 then am6 = 1 end
			if t == 40 then am6 = 0 end
			if t == 35 then am7 = 1 end
			if t == 45 then am7 = 0 end
			if t == 40 then am8 = 1 end
			if t == 50 then am8 = 0 end
			if t == 45 then am9 = 1 end
			if t == 55 then am9 = 0 end


			--Red
			if t == 0 then 	es = 1 	end
			if t == 15 then es = 0	end
			if t == 30 then es = 1	end
			if t == 45 then es = 0	end

			--Blue
			if t == 15 then di = 1 	end
			if t == 30 then di = 0	end
			if t == 45 then di = 1 	end
			if t == 59 then di = 0	end


			--farol
			if t == 0 then 	fa1 = 1 end
			if t == 15 then fa1 = 0 end
			if t == 30 then fa1 = 1 end
			if t == 45 then fa1 = 0 end

			if t == 15 then fa2 = 1 end
			if t == 30 then fa2 = 0	end
			if t == 45 then fa2 = 1 end
			if t == 59 then fa2 = 0	end

			--farol luz
			if t == 0 then 	fa3 = 10 end
			if t == 15 then fa3 = 0 end
			if t == 30 then fa3 = 10 end
			if t == 45 then fa3 = 0 end

			if t == 15 then fa4 = 10 end
			if t == 30 then fa4 = 0	end
			if t == 45 then fa4 = 10 end
			if t == 59 then fa4 = 0	end

			if t == 0 then 	fa5 = 1 end
			if t == 15 then fa5 = 0 end
			if t == 30 then fa5 = 1 end
			if t == 45 then fa5 = 0 end

			if t == 15 then fa6 = 1 end
			if t == 30 then fa6 = 0	end
			if t == 45 then fa6 = 1 end
			if t == 59 then fa6 = 0	end




SetShapeEmissiveScale(shapes.ab1, am1)
SetShapeEmissiveScale(shapes.ab2, am2)
SetShapeEmissiveScale(shapes.ab3, am3)
SetShapeEmissiveScale(shapes.ab4, am4)
SetShapeEmissiveScale(shapes.ab5, am5)
SetShapeEmissiveScale(shapes.ab6, am6)
SetShapeEmissiveScale(shapes.ab7, am7)
SetShapeEmissiveScale(shapes.ab8, am8)
SetShapeEmissiveScale(shapes.ab9, am9)
SetShapeEmissiveScale(shapes.ab10, am1)
SetShapeEmissiveScale(shapes.ab11, am2)
SetShapeEmissiveScale(shapes.ab12, am3)
SetShapeEmissiveScale(shapes.ab13, am4)
SetShapeEmissiveScale(shapes.ab14, am5)
SetShapeEmissiveScale(shapes.ab15, am6)
SetShapeEmissiveScale(shapes.ab16, am7)
SetShapeEmissiveScale(shapes.ab17, am8)
SetShapeEmissiveScale(shapes.ab18, am9)

SetShapeEmissiveScale(shapes.td, di)
SetShapeEmissiveScale(shapes.te, es)
SetShapeEmissiveScale(shapes.td2, di)
SetShapeEmissiveScale(shapes.te2, es)
SetShapeEmissiveScale(shapes.rd, di)
SetShapeEmissiveScale(shapes.re, es)
SetShapeEmissiveScale(shapes.rtd, di)
SetShapeEmissiveScale(shapes.rte, es)
SetShapeEmissiveScale(shapes.fd, di)
SetShapeEmissiveScale(shapes.fe, es)
SetShapeEmissiveScale(shapes.fd2, di)
SetShapeEmissiveScale(shapes.fe2, es)

SetLightIntensity(lights.ab1, am1)
SetLightIntensity(lights.ab2, am2)
SetLightIntensity(lights.ab3, am3)
SetLightIntensity(lights.ab4, am4)
SetLightIntensity(lights.ab5, am5)
SetLightIntensity(lights.ab6, am6)
SetLightIntensity(lights.ab7, am7)
SetLightIntensity(lights.ab8, am8)
SetLightIntensity(lights.ab9, am9)
SetLightIntensity(lights.ab10, am1)
SetLightIntensity(lights.ab11, am2)
SetLightIntensity(lights.ab12, am3)
SetLightIntensity(lights.ab13, am4)
SetLightIntensity(lights.ab14, am5)
SetLightIntensity(lights.ab15, am6)
SetLightIntensity(lights.ab16, am7)
SetLightIntensity(lights.ab17, am8)
SetLightIntensity(lights.ab18, am9)

SetLightIntensity(lights.td, di)
SetLightIntensity(lights.te, es)
SetLightIntensity(lights.td2, di)
SetLightIntensity(lights.te2, es)
SetLightIntensity(lights.td3, di)
SetLightIntensity(lights.te3, es)
SetLightIntensity(lights.td4, di)
SetLightIntensity(lights.te4, di)
SetLightIntensity(lights.td5, di)
SetLightIntensity(lights.te5, es)
SetLightIntensity(lights.rd, di)
SetLightIntensity(lights.rd2, di)
SetLightIntensity(lights.re, es)
SetLightIntensity(lights.rtd, di)
SetLightIntensity(lights.rte, es)
SetLightIntensity(lights.rte2, es)
SetLightIntensity(lights.fd, di)
SetLightIntensity(lights.fe, es)
SetLightIntensity(lights.fd2, di)
SetLightIntensity(lights.fe2, es)
SetShapeEmissiveScale(shapes.lflm2, fa1)
SetLightIntensity(lights.lflml2, fa3)
SetShapeEmissiveScale(shapes.lfrm2, fa2)
SetLightIntensity(lights.lflmr2, fa4)
SetShapeEmissiveScale(shapes.lflmt2, fa1)
SetLightIntensity(lights.lflmlt2, fa5)
SetShapeEmissiveScale(shapes.lfrmt2, fa2)
SetLightIntensity(lights.lfrmrt2, fa6)

else

SetShapeEmissiveScale(shapes.ab1, 0)
SetShapeEmissiveScale(shapes.ab2, 0)
SetShapeEmissiveScale(shapes.ab3, 0)
SetShapeEmissiveScale(shapes.ab4, 0)
SetShapeEmissiveScale(shapes.ab5, 0)
SetShapeEmissiveScale(shapes.ab6, 0)
SetShapeEmissiveScale(shapes.ab7, 0)
SetShapeEmissiveScale(shapes.ab8, 0)
SetShapeEmissiveScale(shapes.ab9, 0)
SetShapeEmissiveScale(shapes.ab10, 0)
SetShapeEmissiveScale(shapes.ab11, 0)
SetShapeEmissiveScale(shapes.ab12, 0)
SetShapeEmissiveScale(shapes.ab13, 0)
SetShapeEmissiveScale(shapes.ab14, 0)
SetShapeEmissiveScale(shapes.ab15, 0)
SetShapeEmissiveScale(shapes.ab16, 0)
SetShapeEmissiveScale(shapes.ab17, 0)
SetShapeEmissiveScale(shapes.ab18, 0)
SetShapeEmissiveScale(shapes.td, 0)
SetShapeEmissiveScale(shapes.te, 0)
SetShapeEmissiveScale(shapes.td2, 0)
SetShapeEmissiveScale(shapes.te2, 0)
SetShapeEmissiveScale(shapes.rd, 0)
SetShapeEmissiveScale(shapes.re, 0)
SetShapeEmissiveScale(shapes.rtd, 0)
SetShapeEmissiveScale(shapes.rte, 0)
SetShapeEmissiveScale(shapes.fd, 0)
SetShapeEmissiveScale(shapes.fe, 0)
SetShapeEmissiveScale(shapes.fd2, 0)
SetShapeEmissiveScale(shapes.fe2, 0)

SetLightIntensity(lights.ab1, 0)
SetLightIntensity(lights.ab2, 0)
SetLightIntensity(lights.ab3, 0)
SetLightIntensity(lights.ab4, 0)
SetLightIntensity(lights.ab5, 0)
SetLightIntensity(lights.ab6, 0)
SetLightIntensity(lights.ab7, 0)
SetLightIntensity(lights.ab8, 0)
SetLightIntensity(lights.ab9, 0)
SetLightIntensity(lights.ab10, 0)
SetLightIntensity(lights.ab11, 0)
SetLightIntensity(lights.ab12, 0)
SetLightIntensity(lights.ab13, 0)
SetLightIntensity(lights.ab14, 0)
SetLightIntensity(lights.ab15, 0)
SetLightIntensity(lights.ab16, 0)
SetLightIntensity(lights.ab17, 0)
SetLightIntensity(lights.ab18, 0)
SetLightIntensity(lights.td, 0)
SetLightIntensity(lights.te, 0)
SetLightIntensity(lights.td2, 0)
SetLightIntensity(lights.te2, 0)
SetLightIntensity(lights.td3, 0)
SetLightIntensity(lights.te3, 0)
SetLightIntensity(lights.td4, 0)
SetLightIntensity(lights.te4, 0)
SetLightIntensity(lights.td5, 0)
SetLightIntensity(lights.te5, 0)
SetLightIntensity(lights.rd, 0)
SetLightIntensity(lights.rd2, 0)
SetLightIntensity(lights.re, 0)
SetLightIntensity(lights.rtd, 0)
SetLightIntensity(lights.rte, 0)
SetLightIntensity(lights.rte2, 0)
SetLightIntensity(lights.fd, 0)
SetLightIntensity(lights.fe, 0)
SetLightIntensity(lights.fd2, 0)
SetLightIntensity(lights.fe2, 0)


	end


	if elight2 then
			local period = 60
			local t = frame%period
			--toplights
			if t == 0 then 	am1 = 1 end
			if t == 5 then am1 = 0 end
			if t == 10 then am1 = 1 end
			if t == 15 then am1 = 0 end
			if t == 20 then am1 = 1 end
			if t == 25 then am1 = 0 end

			if t == 5 then am2 = 1 end
			if t == 15 then am2 = 0 end
			if t == 10 then am3 = 1 end
			if t == 20 then am3 = 0 end
			if t == 40 then am2 = 1 end
			if t == 50 then am2 = 0 end
			if t == 35 then am3 = 1 end
			if t == 45 then am3 = 0 end


			if t == 30 then am4 = 1 end
			if t == 35 then am4 = 0 end
			if t == 40 then am4 = 1 end
			if t == 45 then am4 = 0 end
			if t == 50 then am4 = 1 end
			if t == 55 then am4 = 0 end

			if t == 20 then am5 = 1 end
			if t == 35 then am5 = 0 end

			if t == 30 then am6 = 1 end
			if t == 35 then am6 = 0 end
			if t == 40 then am6 = 1 end
			if t == 45 then am6 = 0 end
			if t == 50 then am6 = 1 end
			if t == 55 then am6 = 0 end

			if t == 10 then am7 = 1 end
			if t == 20 then am7 = 0 end
			if t == 5 then am8 = 1 end
			if t == 15 then am8 = 0 end
			if t == 35 then am7 = 1 end
			if t == 45 then am7 = 0 end
			if t == 40 then am8 = 1 end
			if t == 50 then am8 = 0 end

			if t == 0 then am9 = 1 end
			if t == 5 then am9 = 0 end
			if t == 10 then am9 = 1 end
			if t == 15 then am9 = 0 end
			if t == 20 then am9 = 1 end
			if t == 25 then am9 = 0 end




			--Red
			if t == 0 then 	es = 1	end
			if t == 5 then es = 0	end
			if t == 10 then es = 1 	end
			if t == 30 then es = 0	end

			--Blue
			if t == 30 then di = 1 	end
			if t == 35 then di = 0	end
			if t == 40 then di = 1 	end
			if t == 59 then di = 0	end



			--farol
			if t == 0 then 	fa1 = 1 end
			if t == 5 then fa1 = 0 end
			if t == 10 then fa1 = 1 end
			if t == 30 then fa1 = 0 end

			if t == 30 then fa2 = 1 end
			if t == 35 then fa2 = 0	end
			if t == 40 then fa2 = 1 end
			if t == 59 then fa2 = 0	end

			--farol luz
			if t == 0 then 	fa3 = 10 end
			if t == 5 then fa3 = 0 end
			if t == 10 then fa3 = 10 end
			if t == 30 then fa3 = 0 end

			if t == 30 then fa4 = 10 end
			if t == 35 then fa4 = 0	end
			if t == 40 then fa4 = 10 end
			if t == 59 then fa4 = 0	end

			if t == 0 then 	fa5 = 1 end
			if t == 5 then fa5 = 0 end
			if t == 10 then fa5 = 1 end
			if t == 30 then fa5 = 0 end

			if t == 30 then fa6 = 1 end
			if t == 35 then fa6 = 0	end
			if t == 40 then fa6 = 1 end
			if t == 59 then fa6 = 0	end



SetShapeEmissiveScale(shapes.ab1, am1)
SetShapeEmissiveScale(shapes.ab2, am2)
SetShapeEmissiveScale(shapes.ab3, am3)
SetShapeEmissiveScale(shapes.ab4, am4)
SetShapeEmissiveScale(shapes.ab5, am5)
SetShapeEmissiveScale(shapes.ab6, am6)
SetShapeEmissiveScale(shapes.ab7, am7)
SetShapeEmissiveScale(shapes.ab8, am8)
SetShapeEmissiveScale(shapes.ab9, am9)
SetShapeEmissiveScale(shapes.ab10, am1)
SetShapeEmissiveScale(shapes.ab11, am2)
SetShapeEmissiveScale(shapes.ab12, am3)
SetShapeEmissiveScale(shapes.ab13, am4)
SetShapeEmissiveScale(shapes.ab14, am5)
SetShapeEmissiveScale(shapes.ab15, am6)
SetShapeEmissiveScale(shapes.ab16, am7)
SetShapeEmissiveScale(shapes.ab17, am8)
SetShapeEmissiveScale(shapes.ab18, am9)

SetShapeEmissiveScale(shapes.td, di)
SetShapeEmissiveScale(shapes.te, es)
SetShapeEmissiveScale(shapes.td2, di)
SetShapeEmissiveScale(shapes.te2, es)
SetShapeEmissiveScale(shapes.rd, di)
SetShapeEmissiveScale(shapes.re, es)
SetShapeEmissiveScale(shapes.rtd, di)
SetShapeEmissiveScale(shapes.rte, es)
SetShapeEmissiveScale(shapes.fd, di)
SetShapeEmissiveScale(shapes.fe, es)
SetShapeEmissiveScale(shapes.fd2, di)
SetShapeEmissiveScale(shapes.fe2, es)

SetLightIntensity(lights.ab1, am1)
SetLightIntensity(lights.ab2, am2)
SetLightIntensity(lights.ab3, am3)
SetLightIntensity(lights.ab4, am4)
SetLightIntensity(lights.ab5, am5)
SetLightIntensity(lights.ab6, am6)
SetLightIntensity(lights.ab7, am7)
SetLightIntensity(lights.ab8, am8)
SetLightIntensity(lights.ab9, am9)
SetLightIntensity(lights.ab10, am1)
SetLightIntensity(lights.ab11, am2)
SetLightIntensity(lights.ab12, am3)
SetLightIntensity(lights.ab13, am4)
SetLightIntensity(lights.ab14, am5)
SetLightIntensity(lights.ab15, am6)
SetLightIntensity(lights.ab16, am7)
SetLightIntensity(lights.ab17, am8)
SetLightIntensity(lights.ab18, am9)

SetLightIntensity(lights.td, di)
SetLightIntensity(lights.te, es)
SetLightIntensity(lights.td2, di)
SetLightIntensity(lights.te2, es)
SetLightIntensity(lights.td3, di)
SetLightIntensity(lights.te3, es)
SetLightIntensity(lights.td4, di)
SetLightIntensity(lights.te4, di)
SetLightIntensity(lights.td5, di)
SetLightIntensity(lights.te5, es)
SetLightIntensity(lights.rd, di)
SetLightIntensity(lights.rd2, di)
SetLightIntensity(lights.re, es)
SetLightIntensity(lights.rtd, di)
SetLightIntensity(lights.rte, es)
SetLightIntensity(lights.rte2, es)
SetLightIntensity(lights.fd, di)
SetLightIntensity(lights.fe, es)
SetLightIntensity(lights.fd2, di)
SetLightIntensity(lights.fe2, es)
SetShapeEmissiveScale(shapes.lflm2, fa1)
SetLightIntensity(lights.lflml2, fa3)
SetShapeEmissiveScale(shapes.lfrm2, fa2)
SetLightIntensity(lights.lflmr2, fa4)
SetShapeEmissiveScale(shapes.lflmt2, fa1)
SetLightIntensity(lights.lflmlt2, fa5)
SetShapeEmissiveScale(shapes.lfrmt2, fa2)
SetLightIntensity(lights.lfrmrt2, fa6)


	end
end
