
-- Constants
BUTTON_SIZE = 75
BUTTON_PADDING = 8
NUMBER_Y = 140
BUTTON_Y = 480
NUMBER_FONT_SIZE = 100
BUTTON_FONT_SIZE = 45
ARROW_X = 145
ARROW_WIDTH = 105
MAX_DIGITS = 1

numberBuffer = ""   -- Keep track of what digits the player is pressing
keyPressTimeout = 0 -- For if a single digit is pressed

function tick()	
	screen = UiGetScreen()
    elevatorId = GetTagValue(screen, "id")
end

function draw()
	if screen == 0 then
		return
	end
	
	if GetPlayerScreen() ~= screen then
		resetBuffer()
	end

	UiButtonHoverColor(0.8, 0.8, 0.8)
	UiButtonPressColor(1.6, 1.5, 1.2)
	
	UiTranslate(0, 0)
	UiImage("MOD/elevator/panel-background.png")
	
	UiAlign("center middle")
	
	-- Buttons
	UiPush()
	UiTranslate(UiCenter() - BUTTON_SIZE - BUTTON_PADDING, BUTTON_Y)
	UiFont("regular.ttf", BUTTON_FONT_SIZE)
	UiColor(1.0, 1.0, 0.95)
	UiButtonImageBox("MOD/elevator/button.png", 25, 25)
	local sizeAndPadding = BUTTON_SIZE + BUTTON_PADDING
	--[[for y=0,2 do
		for x=0,2 do
			local i = (y * 3) + x + 1
			UiPush()
			UiTranslate(x * sizeAndPadding, y * sizeAndPadding)
			if button(i) then
				keyPressTimeout = GetTime() + 2
				addToBuffer(i)
			end
			UiPop()
		end
	end]]--
	UiTranslate(0, 0)
	UiTranslate(sizeAndPadding, 0)
	UiTranslate(sizeAndPadding, 0)
	UiTranslate(-166, sizeAndPadding)
	UiTranslate(sizeAndPadding, 0)
	if button2("Küche") then
		numberBuffer = "K"
	end
	UiTranslate(sizeAndPadding, 0)
	UiTranslate(-166, sizeAndPadding)
	UiTranslate(sizeAndPadding, 0)
	if button2("Schlafzimmer") then
		numberBuffer = "S"
	end
	UiTranslate(-83, sizeAndPadding)
	UiTranslate(sizeAndPadding, 0)
	if button2("Erdgeschoss") then
		numberBuffer = "E"
	end
	UiTranslate(-83, sizeAndPadding)
	UiTranslate(sizeAndPadding, 0)
	if button2("Ausguck") then
		numberBuffer = "A"
	end
	UiTranslate(-83, sizeAndPadding)
	UiTranslate(sizeAndPadding, 0)
	if button2("Labor") then
		numberBuffer = "L"
	end
	UiTranslate(-83, sizeAndPadding)
	UiTranslate(sizeAndPadding, 0)
	if button2("Bunker") then
		numberBuffer = "B"
	end
	UiTranslate(-83, 75+8+30)
	if button(">|<") then
		--placebo button lol
	end
	UiTranslate(sizeAndPadding, 0)
	if button("!") then
		--fake alarm
	end
	UiTranslate(sizeAndPadding, 0)
	if button("<|>") then
		--placebo button lol
	end
	UiPop()
	
	-- Floor number
	local currentFloor = getCurrentFloor()
	local destFloor = getDestinationFloor()
	UiFont("MOD/elevator/DisplayFont.ttf", NUMBER_FONT_SIZE)
	UiColor(1.0, 0.0, 0.0)
	UiTranslate(ARROW_X , NUMBER_Y)
	if currentFloor < getDestinationFloor() then
		UiImage("MOD/elevator/arrow.png")
	elseif currentFloor > getDestinationFloor() then
		UiPush()
		UiRotate(180)
		UiImage("MOD/elevator/arrow.png")
		UiPop()
	end
	UiTranslate(ARROW_WIDTH, 0)
	local valueToShow = currentFloor
	if valueToShow == 1 then
		valueToShow = "LB"
	end
	if valueToShow == 2 then
		valueToShow = "AG"
	end
	if valueToShow == 3 then
		valueToShow = "EG"
	end
	if valueToShow == 4 then
		valueToShow = "SZ"
	end
	if valueToShow == 5 then
		valueToShow = "KÜ"
	end
	if valueToShow == 0 then
		valueToShow = "BU"
	end
	if getInspection() == 1 then
		valueToShow = "IS"
	end
	UiText(valueToShow)
	
	-- Check if ok to set destination
	if GetPlayerScreen() == screen and (numberBuffer == "G" or #numberBuffer >= MAX_DIGITS or (keyPressTimeout > 0 and GetTime() > keyPressTimeout)) then
		keyPressTimeout = 0
		if numberBuffer == "L" then
			setDestinationFloor(1)
		elseif numberBuffer == "A" then
			setDestinationFloor(2)
		elseif numberBuffer == "E" then
			setDestinationFloor(3)
		elseif numberBuffer == "S" then
			setDestinationFloor(4)
		elseif numberBuffer == "K" then
			setDestinationFloor(5)
		elseif numberBuffer == "B" then
			setDestinationFloor(0)
		else
			setDestinationFloor(tonumber(numberBuffer))
		end
		SetPlayerScreen(0)
	end
end


function getCurrentFloor()
	return GetInt("level.elevator" .. elevatorId .. ".currentFloor")
end

function getDestinationFloor()
	return GetInt("level.elevator" .. elevatorId .. ".destinationFloor")
end

function getInspection()
	return GetInt("level.elevator" .. elevatorId .. ".ins")
end

function setDestinationFloor(num)
	SetInt("level.elevator" .. elevatorId .. ".destinationFloor", num)
end

function button(label)
	return UiTextButton(tostring(label), BUTTON_SIZE, BUTTON_SIZE) or InputPressed(tostring(label))
end

function button2(label)
	return UiTextButton(tostring(label), 300, 75) or InputPressed(tostring(label))
end

function addToBuffer(num)
	numberBuffer = numberBuffer .. tostring(num)
end

function resetBuffer()
	numberBuffer = ""
end