
-- Constants
NUMBER_Y = 70
NUMBER_FONT_SIZE = 70
ARROW_X = 45
ARROW_WIDTH = 105
MAX_DIGITS = 1

numberBuffer = ""   -- Keep track of what digits the player is pressing
keyPressTimeout = 0 -- For if a single digit is pressed

function tick()	
	screen = UiGetScreen()
    elevatorId = GetTagValue(screen, "id")
end

function draw()
	if screen == 0 then
		return
	end
	
	UiButtonHoverColor(0.8, 0.8, 0.8)
	UiButtonPressColor(1.6, 1.5, 1.2)
	
	UiTranslate(0, 0)
	UiImage("MOD/elevator/panel2.jpg")
	
	UiTranslate(55, 470)
	UiAlign("center top")
	
	
	-- Floor number
	local currentFloor = getCurrentFloor()
	local destFloor = getDestinationFloor()
	UiFont("MOD/elevator/arial.ttf", NUMBER_FONT_SIZE)
	UiColor(0.0, 0.0, 0.0)
	UiTranslate(ARROW_X , NUMBER_Y)
	if currentFloor < getDestinationFloor() then
		UiImage("MOD/elevator/arrow.png")
	elseif currentFloor > getDestinationFloor() then
		UiImage("MOD/elevator/arrow2.png")
	end
	UiTranslate(50, 0) -- ARROW_WIDTH
	if GetPlayerScreen() == screen then
		
	else
		-- Display the current floor
		local valueToShow = currentFloor
		if valueToShow == 0 then
			valueToShow = "E"
		end
		if getInspection() == 1 then
			valueToShow = " IS"
		end
		UiText(valueToShow)
	end

end


function getCurrentFloor()
	return GetInt("level.elevator" .. elevatorId .. ".currentFloor")
end

function getDestinationFloor()
	return GetInt("level.elevator" .. elevatorId .. ".destinationFloor")
end

function getInspection()
	return GetInt("level.elevator" .. elevatorId .. ".ins")
end

function button(label)
	return UiTextButton(tostring(label), BUTTON_SIZE, BUTTON_SIZE) or InputPressed(tostring(label))
end

function addToBuffer(num)
	numberBuffer = numberBuffer .. tostring(num)
end

function resetBuffer()
	numberBuffer = ""
end