visible = 0

function init()
	SetValue("visible", 1.0, "cosine", 0.5)
end

function tick()
	--Put a scripting menu button on the pause menu for all levels, except the main menu
	if not string.find(GetString("game.levelpath"), "main.xml") then
		if PauseMenuButton("Scripting Showcase Menu") then
			StartLevel("", "MOD/main.xml")
		end
	end
end


function draw()	
	local path = GetString("game.levelpath")
	if string.find(path, "full.xml") then
		infoBox("Volle Version")
	elseif string.find(path, "minimal.xml") then
		infoBox("Minimale Version")
	elseif string.find(path, "nonpc.xml") then
		infoBox("Keine NPCs")
	elseif string.find(path, "nomobs.xml") then
		infoBox("Keine Zombies oder Creeper")
	elseif string.find(path, "labor.xml") then
		infoBox("Das Labor")
	elseif string.find(path, "main.xml") then
		infoBox("Wähle ein Level")
	else
		--Print message about making a local copy only if it's not already a local copy
		local localMsg = ""
		if string.sub(GetString("game.mod"), 0, 5) ~= "local" then
			localMsg = "Welcome to the scripting showcase. We recommend making a local copy of this mod so you can more easily view and alter the scripts it uses. "
		end
		infoBox(localMsg .. "This is the showcase menu. It consists of a simple scene and a script that lets you select different levels. The script for this menu is script/menu.lua. This scene is defined in the default level file main.xml.\n\nThis text is added by main.lua, which is always running on all levels in this mod. The main.lua script figures out which level you are running and displays a different message for each one. It also adds a button on the pause menu to get back to this main menu.")
	end
end


function infoBox(txt)
	UiPush()
		UiFont("regular.ttf", 22)
		UiWordWrap(500)

		local w,h = UiGetTextSize(txt)
		UiTranslate(20-600*(1-visible), UiHeight()-h-50)
		UiColor(0,0,0, 0.7)
		UiImageBox("ui/common/box-solid-10.png", w+40, h+30, 10, 10)
		UiTranslate(20, 35)
		
		UiColor(1,1,1)
		UiText(txt)
	UiPop()
end
