RED = {r=1,g=0,b=0,a=1}
DARK_RED = {r=.5,g=0,b=0,a=1}
LIGHT_RED = {r=1,g=0.5,b=0.5,a=1}
GREEN = {r=0,g=1,b=0,a=1}
YELLOW = {r=1,g=1,b=0,a=1}
BLACK = {r=0.1,g=0,b=0,a=1}
WHITE = {r=1,g=1,b=1,a=1}

HEAD_SIZE = 30
BODY_WIDTH = 38
BODY_HEIGHT= 60
ARM_WIDTH = 18

COLORS = {red=RED,green=GREEN,yellow=YELLOW}

HEALTHY = "healthy"
INJURED = "injured"
DEAD = "dead"

function Effect(title, color)
	return {text=title, color=color}
end

function BodyState(overall, head, body, leftArm, leftLowerArm, rightArm, rightLowerArm, leftLeg, leftLowerLeg, rightLeg, rightLowerLeg, effects)
	if effects == nil then effects = {} end
	return {overall=overall, head=head, body=body, leftArm=leftArm, leftLowerArm=leftLowerArm, rightArm=rightArm, rightLowerArm=rightLowerArm, leftLeg=leftLeg, leftLowerLeg=leftLowerLeg, rightLeg=rightLeg, rightLowerLeg=rightLowerLeg, effects=effects}
end

function BodyPart(color, effects)
	if effects == nil then effects = {} end
	return {color=color, effects=effects}
end

BROKEN_BODY_PART = BodyPart(RED, {Effect("wounded", RED)})
DISABLED_BODY_PART = BodyPart(BLACK, {Effect("disabled", YELLOW)})
BLEEDING_BODY_PART = BodyPart(DARK_RED, {Effect("bleeding", LIGHT_RED)})
BROKEN_NECK = BodyPart(RED, {Effect("broken neck", RED)}) 
HEALTHY_BODY_PART = BodyPart(GREEN, {Effect("healthy", GREEN)})
BANDAGED_BODY_PART = BodyPart(WHITE, {Effect("bandaged", WHITE)})

HEALTHY_BODY_STATE = BodyState(
		HEALTHY,
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),	
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		BodyPart(GREEN, {}),
		{}
	)

function UiDrawBodyState(state)	
	UiTranslate(ARM_WIDTH+2+(BODY_WIDTH-HEAD_SIZE)/2,0)
	UiDrawHead(state.head.color)
	UiTranslate(-(BODY_WIDTH-HEAD_SIZE)/2,HEAD_SIZE+2)
	UiDrawBody(state.body.color)
	UiPush()
		UiTranslate(-ARM_WIDTH-2,0)
		UiDrawArm(state.rightArm.color)
		
		UiTranslate(0,BODY_HEIGHT/2+1)
		UiDrawArm(state.rightLowerArm.color)
	UiPop()
	UiPush()
		UiTranslate(BODY_WIDTH+3,0)
		UiDrawArm(state.leftArm.color)
		
		UiTranslate(0,BODY_HEIGHT/2+1)
		UiDrawArm(state.leftLowerArm.color)
	UiPop()
	UiPush()
		UiTranslate(0,BODY_HEIGHT+2)
		UiDrawArm(state.rightLeg.color)
		
		UiTranslate(0,BODY_HEIGHT/2+1)
		UiDrawArm(state.rightLowerLeg.color)
	UiPop()
	UiPush()
		UiTranslate(ARM_WIDTH+2,BODY_HEIGHT+2)
		UiDrawArm(state.leftLeg.color)
		
		UiTranslate(0,BODY_HEIGHT/2+1)
		UiDrawArm(state.leftLowerLeg.color)
	UiPop()
end

function UiDrawHead(color)
	drawRect(0,0,HEAD_SIZE,HEAD_SIZE,color.r,color.g,color.b,color.a)
end

function UiDrawBody(color)
	drawRect(0,0,BODY_WIDTH,BODY_HEIGHT,color.r,color.g,color.b,color.a)
end

function UiDrawArm(color)
	drawRect(0,0,ARM_WIDTH,BODY_HEIGHT/2-1,color.r,color.g,color.b,color.a)
end