#include "UiHealthOverlay.lua"

function init()
	
	local defaultvals = {
		{
			key = "savegame.mod.bleed",
			func = function(a) SetBool(a, true) end
		},
		{
			key = "savegame.mod.bloodcolor",
			func = function(a) SetBool(a, false) end
		},
		{
			key = "savegame.mod.gore",
			func = function(a) SetInt(a, 2) end
		},
		{
			key = "savegame.mod.blood_intensity",
			func = function(a) SetInt(a, 5) end
		},
		{
			key = "savegame.mod.central_mult",
			func = function(a) SetInt(a, 10) end
		},
		{
			key = "savegame.mod.global_mult",
			func = function(a) SetInt(a, 2) end
		}
	}

	for _, save in pairs(defaultvals) do
		if not HasKey(save.key) then
			save.func(save.key)
		end
	end

	MyHealthUiIsActive = false
	RagdollBody = {}

	sbloodval = {};
	bloodval = {};
	currentbloodvalue = {};
	Puddles = {};
	
	Torso = FindBody("Torso")
	
	bodyparts = FindBodies("bodypart")
	starttotalbloodvalue = 0
	for i=1,#bodyparts do
			bodypart = bodyparts[i]
			bodypartshapes = GetBodyShapes(bodypart)
			SetTag(bodypart, "lonardo")
			--DebugPrint(#bodypartshapes)
			for h=1,#bodypartshapes do
			SetTag(bodypartshapes[h], "fxbreak","l3red")
			SetTag(bodypartshapes[h], "lonardo")
			--DebugPrint("Set")
			end

		RagdollBody[bodypart] = 1
		bodypartstartmass = GetBodyMass(bodypart)
		table.insert(sbloodval, bodypartstartmass)
		table.insert(bloodval, bodypartstartmass)
		table.insert(currentbloodvalue, bodypartstartmass)
		--table.insert(puddles, {pos={x,y,z}, amount=3.0})
		starttotalbloodvalue = starttotalbloodvalue + GetBodyMass(bodypart)
	end
	bleed = 0
	puddleregtim = 0
	repuddle = 0.1
	mergepuddledistance = 1
	puddleneutspeed = 0.2
	GrowSpeed = 0.002
	
	upspeed = 50
	headvel = Vec(0,GetBodyMass(FindBody("RRLEG"))/upspeed,0)
	--DebugPrint("HeadMass: "..headvel)
	legvel = Vec(0,-GetBodyMass(FindBody("LLLEG"))/20,0)
	recoverfromtrip = 3
	triptim = 0
	tripped = false
	restartjoints = false
	trippingspeed = 10
	jointstrength = 10	
	sretractjoint = 12
	retractjoint = sretractjoint
	retractjoint1 = sretractjoint
	retractjoint2 = sretractjoint
	retractjoint3 = sretractjoint
	retractjoint4 = sretractjoint
	retractjoint5 = sretractjoint
	panictim = 0
	actualpanictim = 0
	criticalcough = LoadLoop("MOD/main/Gore Ragdolls 2/snd/criticalcondition.ogg")
	goresplat = LoadSound("MOD/main/Gore Ragdolls 2/snd/goresplat.ogg")
	headsplat = LoadSound("MOD/main/Gore Ragdolls 2/snd/headsplat.ogg")
	drowntim = 0
	inpostim = 0
	deadtim = 0
	globalbleedintensity = 0
	directbleedmultiplier = GetInt("savegame.mod.central_mult")/1000
	globalbleedmultiplier = GetInt("savegame.mod.global_mult")/1000
	
	--SetHeadHealth(RED)
	--AddHeadHealthEffect("argh",RED)
	UI = FindLocations("UIISADDED", true)
	--if UI == nil then
		Spawn("MOD/prefab/UISPAWN.xml", Vec(0,0,0))
		Spawn("MOD/prefab/GoreFX.xml", Vec(0,0,0))
	--end
	manualdietim = 0
	gorelevel = GetInt("savegame.mod.gore")
	bleedbool = GetBool("savegame.mod.bleed")
	blood_intensity = GetInt("savegame.mod.blood_intensity")/10
	Puddlemaxsize = blood_intensity*1
	if gorelevel == 4 then
		multiplier = 2
	else
		multiplier = 1
	end
	--DebugPrint(gorelevel)
	keytokill = GetString("savegame.mod.gore_kill")
	nameList = {'Carl', 'Arthur', 'Ryan', 'Roger', 'Joe', 'Juan', 'Jack', 'Albert', 'Jonathan', 'Justin', 'Terry', 'Gerald', 'Keith', 'Samuel', 'Willie', 'Ralph', 'Lawrence', 'Nicholas', 'Roy', 'Benjamin', 'Bruce', 'Brandon', 'Adam', 'Harry', 'Fred', 'Wayne', 'Billy', 'Steve', 'Louis', 'Jeremy', 'Aaron', 'Randy', 'Howard', 'Eugene', 'Carlos', 'Russell', 'Bobby', 'Victor', 'Martin', 'Ernest', 'Phillip', 'Todd', 'Jesse', 'Craig', 'Alan', 'Shawn', 'Clarence', 'Sean', 'Philip'}
	bodyState.name = nameList[math.random(1,#nameList)]
	
end

function tick()
	CheckHealthUi()
end

function draw(dt)
	DrawUiHealthOverlay(dt)
	if warn then
	UiPush()
      UiAlign("center middle")
      --UiTranslate(400, 200)
      UiFont("bold.ttf", 30)
      UiColor(1,0,0)
      UiText("PRESS"..keytokill.." AGAIN TO KILL ALL RAGDOLLS: "..10 - manualdietim)
     UiPop()
 end
end

local sedated = false
local bandageIndex = -1
local resurrectIndex = -1

function update(dt)
--[[
	if manualdietim < 10 then
		if InputPressed(keytokill) and warn then
		entirelystop = true
		warn = false
		manualdietim = 0
		end
	else
		warn = false
		manualdietim = 0
	end
	if InputPressed(keytokill) and not warn and not entirelystop then
		warn = true
	end
	if warn then
		manualdietim = manualdietim + dt
	end]]--
if not entirelystop then
	if not tripped and not sitting then
		knees = FindJoints("knee")
		for i=1,#knees do
			panick()
			--if not IsJointBroken(hips[i]) then
				SetJointMotor(knees[i], -retractjoint3/4,jointstrength)
			--end
		end
	end

	jaw = FindShape("jaw")
	if not dead then
		jaw = FindShape("jaw")
		evtelse = FindShapes("")
		SetShapeCollisionFilter(jaw, 2, 255-2)
		torsos = GetBodyShapes(FindBody("Torso"))
		for i=1,#torsos do
		SetShapeCollisionFilter(torsos[i], 2, 255-2)
		end
		jawjoints = GetShapeJoints(jaw)
		for i=1,#jawjoints do
			SetJointMotor(jawjoints[i], 0.5)
		end
	else
		jawjoints = GetShapeJoints(jaw)
		for i=1,#jawjoints do
			SetJointMotor(jawjoints[i], 0, 0)
		end
	end
	if panic then
		SetTag(Torso, "panicked")
		panictim = panictim + dt
		actualpanictim = actualpanictim + dt
	else
		RemoveTag(Torso, "panicked")
	end
	if tripped then
		SetTag(Torso, "tripped")
	else
		RemoveTag(Torso, "tripped")
	end
	bodyparts = FindBodies("bodypart")
	if tripped then
		cower()
		triptim = triptim + dt
		if triptim > recoverfromtrip and VecLength(GetBodyVelocity(FindBody("Torso"))) < trippingspeed then
			tripped = false
			panic = false
			triptim = 0
		end
	end

	local bleedCheck = false
	local bleedSum = 0
	for i=1,#bodyparts do
		bodypart = bodyparts[i]
		SetTag(bodypart, "nocull")
		
		--SetTag(bodypart, "blood", sbloodval[i])
		bodypartcurrentmass = GetBodyMass(bodypart)
		
		bodyparttransform = GetBodyTransform(bodypart)
		--DebugPrint(bloodval[i])
		
		--DebugPrint(currentbloodvalue[i])
		
		if HasTag(bodypart, "sedated") then
			sedated = true
			RemoveTag(bodypart, "sedated")
			restartjointsfunc()
			bodyState.sedated = true
		end
		
		
		if bandageIndex ~= -1 then
			sbloodval[i] = bodypartcurrentmass
			globalbleedintensity = 0
			if bandageIndex == i then
				bandageIndex = -1
				RemoveTag(bodypart, "bandaged")
				globalbleedintensity = 0
				bleedintensity = 0
			end
		end
		if HasTag(bodypart, "bandaged") then
			bandageIndex = i
			globalbleedintensity = 0
			--sbloodval[i] = bloodval[i]
			--RemoveTag(bodypart, "bandaged")
			--DebugPrint("bandaged")
		else
			bloodval[i] = bodypartcurrentmass
		end
		
		if resurrectIndex ~= -1 then
			sbloodval[i] = bodypartcurrentmass
			currentbloodvalue[i] = sbloodval[i]
			if resurrectIndex == i then
				bodyState.oxLevel = 100
				--currentbloodvalue[i] = sbloodval[i]
				dead = false
				bodyState.overall = "healthy"	
				RemoveTag(Torso, "dead")
				deadtim = 0
				drowntim = 0
				RemoveTag(bodypart, "resurrected")
				resurrectIndex = -1
			end
		end
		
		if HasTag(bodypart, "resurrected") then
			resurrectIndex = i
		end
		
		bleedintensity = (sbloodval[i] - bodypartcurrentmass) * directbleedmultiplier
		
		local deficit = sbloodval[i] - bodypartcurrentmass
		bleedSum = bleedSum + (deficit)
		
		bleedintensity = math.max(bleedintensity, globalbleedintensity)
		
		if currentbloodvalue[i]<=0 and math.abs(bleedintensity) > 0 then
			bleedintensity = 0
		end
		
		if math.abs(bleedintensity)>0 then
			bleedCheck = true
		end
		
		currentbloodvalue[i] = math.max(currentbloodvalue[i] - bleedintensity/75,0)
		SetTag(bodypart, "bloodLevel", currentbloodvalue[i])
		totalbloodvalue = 0
		for z=1,#bodyparts do
			totalbloodvalue = totalbloodvalue+currentbloodvalue[z]
		end
		
		
		if HasTag(bodypart, "Torso") then
			torsovelocity = VecLength(GetBodyVelocity(bodypart))
			if torsovelocity > trippingspeed then
				tripped = true
				panic = true
			end
		end

		if sitting then
			sit()
		end

		if HasTag(bodypart,"Torso") then
			if HasTag(bodypart, "sit") then
				sitting = true
			end
				bodypartpos = GetBodyTransform(bodypart)
				disttobodypart = VecLength(VecSub(GetAimPossit(), bodypartpos.pos))
				cycled = true
				if InputPressed("P") and cycled and not sitting then
				if disttobodypart < 3 then
					sitting = true
					cycled = false
				end
				end

				if InputPressed("P") and cycled and sitting then
				if disttobodypart < 3 then
					sitting = false
					cycled = false
					restartjointsfunc()
					inposition = false
				end
				end
		end

		if HasTag(bodypart, "Head") and not dead then
			if IsPointInWater(bodyparttransform.pos) then
				tripped = true
				drowntim = drowntim + dt
				
			else
				drowntim = math.max(drowntim - dt, 0)
			end
			bodyState.oxLevel = math.floor((5 - drowntim)*20)
		end
		

		if drowntim > 5 then
			if not dead then
				bodyState.timeOfDeath = GetTime()
				bodyState.causeOfDeath = "Drowning"
			end
			dead = true
		end

		if not tripped and HasTag(bodypart, "Head") and not dead and not sitting then
				--Paint(GetAimPos(), (bleedintensity/sbloodval[i])*1.3, "explosion")
				currentvel = GetBodyVelocity(bodypart)
				SetBodyVelocity(bodypart, VecAdd(currentvel, headvel))
				--DebugPrint(VecAdd(currentvel, headvel)[2])
				if IsBodyBroken(bodypart) and deficit > 0 then
					bodyState.head = BROKEN_BODY_PART	
					bodyState.overall = "dead"
					if not dead then
						bodyState.timeOfDeath = GetTime()
						bodyState.causeOfDeath = "Head trauma"
					end
					dead = true
					
					if bloodval[i] < sbloodval[i] - sbloodval[i] / 4 then
					bods = GetBodyShapes(bodypart)
					for i = 1,#bods do
						j = GetShapeJoints(bods[i])
						for z = 1,#j do
							Delete(j[i])
						end
					end
				end
				end
		end

		if not tripped and HasTag(bodypart, "RRLEG") or HasTag(bodypart, "LLLEG") then
			if not dead and not sitting and not tripped then
				--Paint(GetAimPos(), (bleedintensity/sbloodval[i])*1.3, "explosion")
				currentvel = GetBodyVelocity(bodypart)
				SetBodyVelocity(bodypart, VecAdd(currentvel, legvel))
			end
		end

		if IsBodyBroken(bodypart) or currentbloodvalue[i] <= 0 then

			if HasTag(bodypart, "Head") and deficit > 0 then
				if not dead then
					bodyState.timeOfDeath = GetTime()
					bodyState.causeOfDeath = "Head trauma"
				end
				dead = true
			end
			
			if HasTag(bodypart, "LLLEG") or HasTag(bodypart, "LLEG") or HasTag(bodypart, "RRLEG") or HasTag(bodypart, "RLEG") then
				if not tripped then
					panic = true
					tripped = true
					sedated = true
					restartjointsfunc()
				end
			end
		end
		
		function getState(bodypart)
			if HasTag(bodypart, "Torso") or HasTag(bodypart, "Head") then
				if math.abs(bleedintensity)>0 and not IsBodyBroken(bodypart) then
					return BLEEDING_BODY_PART
				elseif currentbloodvalue[i] <= 0 and not IsBodyBroken(bodypart) then
					if not dead then
						dead = true
						bodyState.causeOfDeath = "Blood loss"
						bodyState.timeOfDeath = GetTime()
					end
					return DISABLED_BODY_PART
				elseif IsBodyBroken(bodypart) then
					if currentbloodvalue[i] <= 0 then
						if not dead then
							dead = true
							bodyState.causeOfDeath = "Blood loss"
							bodyState.timeOfDeath = GetTime()
						end
						return DISABLED_BODY_PART
					end
					if bleedintensity == 0 then
						return BANDAGED_BODY_PART
					end
					return BROKEN_BODY_PART
				elseif not IsBodyBroken(bodypart) then
					return HEALTHY_BODY_PART
				end
			else
				if currentbloodvalue[i] <= 0 then
					return DISABLED_BODY_PART
				elseif math.abs(bleedintensity)>0 and not IsBodyBroken(bodypart) then
					return BLEEDING_BODY_PART
				elseif not IsBodyBroken(bodypart) and math.abs(bleedintensity)<=0 then
					return HEALTHY_BODY_PART
				elseif math.abs(bleedintensity)<=0 then
					return BANDAGED_BODY_PART
				end
			end
			return BROKEN_BODY_PART
		end
		
		function getPartName(part)
			if HasTag(part, "LLLEG") then return "leftLowerLeg" end
			if HasTag(part, "LLEG") then return "leftLeg" end
			if HasTag(part, "RRLEG") then return "rightLowerLeg" end
			if HasTag(part, "RLEG") then return "rightLeg" end
			if HasTag(part, "LLARM") then return "leftLowerArm" end
			if HasTag(part, "LARM") then return "leftArm" end
			if HasTag(part, "RRARM") then return "rightLowerArm" end
			if HasTag(part, "RARM") then return "rightArm" end
			if HasTag(part, "Torso") then return "body" end
			if HasTag(part, "Head") then return "head" end
			return "body"
		end
		
		bodyState[getPartName(bodypart)] = getState(bodypart)
	
		--DebugPrint(bleedintensity)
		if (IsBodyBroken(bodypart) and totalbloodvalue > 0 and currentbloodvalue[i] > 0) or (HasTag(bodypart, "Torso") and math.abs(bleedintensity) > 0) then
			
			if bodyState.overall == "healthy" then bodyState.overall = "injured" end
			
			if HasTag(bodypart, "LLLEG") or HasTag(bodypart, "LLEG") then
				--bodyState.leftLeg = BROKEN_BODY_PART
				if not diddit1 and bloodval[i] < sbloodval[i] - sbloodval[i]/3 then
					Spawn("MOD/main/Gore Ragdolls 2/internals/boner.xml", bodyparttransform)
					diddit1 = true
				end
				tripped = true
			elseif HasTag(bodypart, "RRLEG") or HasTag(bodypart, "RLEG") then
				--bodyState.rightLeg = BROKEN_BODY_PART					
				if not diddit2 and bloodval[i] < sbloodval[i] - sbloodval[i]/3 then
					Spawn("MOD/main/Gore Ragdolls 2/internals/boner.xml", bodyparttransform)
					diddit2 = true
				end
				tripped = true
			elseif HasTag(bodypart, "RRARM") or HasTag(bodypart, "RARM") then
				--bodyState.rightArm = BROKEN_BODY_PART	
				if not diddit3 and bloodval[i] < sbloodval[i] - sbloodval[i]/3 then
					Spawn("MOD/main/Gore Ragdolls 2/internals/boner.xml", bodyparttransform)
					diddit3 = true
				end				
			elseif HasTag(bodypart, "LLARM") or HasTag(bodypart, "LARM") then
				--bodyState.leftArm = BROKEN_BODY_PART	
				if not diddit4 and bloodval[i] < sbloodval[i] - sbloodval[i]/3 then
					Spawn("MOD/main/Gore Ragdolls 2/internals/boner.xml", bodyparttransform)
					diddit4 = true
				end							
			end
		
		
			--Paint(GetAimPos(), bleedintensity/sbloodval[i], "explosion")

			puddleregtim = puddleregtim + dt

			PuddleHandleing()
			if puddleregtim > repuddle then
				--for i=1,bleedintensity/10 do
				--DebugPrint(bleedintensity)
				InsertPuddleToTable(bodyparttransform)
				--bleedparticles()
				if bleedbool then
				--Paint(GetAimPos(), bleedintensity/sbloodval[i], "spraycan", .5)
					local bleedsize = math.min(math.abs(bleedintensity/30), 1)
					--Paint(GetAimPos(), bleedsize*3, "spraycan", bleedsize)
					
				end
				--end
				puddleregtim = 0
			end
			if GetBodyMass(bodypart)>0 then
				bleedparticles(GetBodyTransform(bodypart))
			end

			--[[if currentbloodvalue[i] < 1 then ---------------------------------------------------------------
				bleedintensity = 1000
				for i=1,12 do
					InsertPuddleToTable()
				end
				--currentbloodvalue[i] = 0
			end]]--

			if HasTag(bodypart, "Torso") and bloodval[i] < sbloodval[i]/1.2 then			
				--DebugPrint("SUPPOSED TO BE LOL GUTTED XD")
				if not entrailed then
					bodyState.body = BROKEN_BODY_PART
					bodyState.overall = "dead"
					if not dead then
						bodyState.timeOfDeath = GetTime()
						bodyState.causeOfDeath = "Body trauma"
					end
					dead = true
					
					entrailed = true
					for i=1,4 do
						InsertPuddleToTable(bodyparttransform)
					end

					PlaySound(goresplat, GetBodyTransform(Torso).pos, 1)

					if gorelevel ~= 1 then
					Spawn("MOD/main/Gore Ragdolls 2/internals/entrails.xml", bodyparttransform)
					Spawn("MOD/main/Gore Ragdolls 2/internals/Heart.xml", bodyparttransform)
					Spawn("MOD/main/Gore Ragdolls 2/internals/Spine.xml", bodyparttransform)
					if gorelevel ~= 2 then
					for i=1,2 do
					Spawn("MOD/main/Gore Ragdolls 2/internals/Lung.xml", bodyparttransform)
					end
					for i=1,30 * multiplier do
						Spawn("MOD/main/Gore Ragdolls 2/internals/BrainMatter.xml", bodyparttransform)
					end
					end
					end
					--DebugPrint("LOL GUTTED XD")
				end
			end

			if HasTag(bodypart, "Head") and deficit > 0 then
				bodyState.head = BROKEN_BODY_PART	
				bodyState.overall = "dead"	
				eyej = FindJoints("eye")
				if bloodval[i] < sbloodval[i] - sbloodval[i]/4 then
				for i=1,#eyej do
					Delete(eyej[i])
				end
				end
				if bloodval[i] < sbloodval[i] - sbloodval[i]/3 then
				if not fragged then
					fragged = true
					PlaySound(headsplat, GetBodyTransform(Torso).pos, 1)
					if gorelevel ~= 1 then
					for i=1,4 do
						InsertPuddleToTable(bodyparttransform)
					end
					
					
					Spawn("MOD/main/Gore Ragdolls 2/internals/Skull_Jaw.xml.xml", bodyparttransform)
					for i=1,2 * multiplier do
					Spawn("MOD/main/Gore Ragdolls 2/internals/Skull_Eye_Socket.xml", bodyparttransform)
					Spawn("MOD/main/Gore Ragdolls 2/internals/Skull_Fragment.xml", bodyparttransform)
					end
					if gorelevel ~= 2 then
					for i=1,10 * multiplier do
						Spawn("MOD/main/Gore Ragdolls 2/internals/BrainMatter.xml", bodyparttransform)
					end
				end
					end
					--DebugPrint("LOL GUTTED XD")
				end
				end
			end
		end
		
	end

	globalbleedintensity = bleedSum * directbleedmultiplier
	
	bodyState.bloodLevel = totalbloodvalue
	bodyState.bleedIntensity = globalbleedintensity
	
	if bleedCheck then
		PuddleHandleing()
		InsertPuddleToTable()
		--bleedparticles()
	end
	
	--DebugPrint(globalbleedintensity)
	if globalbleedintensity > .1 then
		tripped = true
	end
	if totalbloodvalue < 100 then
		tripped = true
		sedated = true
	end
	
	
	if IsJointBroken(FindJoint("neck")) or totalbloodvalue <= 0 then
		--bodyState.head = BROKEN_NECK						
		bodyState.overall = "dead"
		if not dead then
			bodyState.timeOfDeath = GetTime()
			if totalbloodvalue <= 0 then
				bodyState.causeOfDeath = "Blood loss"
			else
				bodyState.causeOfDeath = "Broken neck"
			end
		end
		dead = true
		
	end
	

	if restartjoints and not tripped then
		restartjointsfunc()
	end

	if dead then
		bodyState.oxLevel = 0
		bodyState.overall = "dead"	
		SetTag(Torso, "dead")
		
		restartjointsfunc()
		deadtim = deadtim + dt
		if deadtim > 60 and not bleedCheck then
			entirelystop = true
		end
	end
else
	for i=1,#bodyparts do
		bodypart = bodyparts[i]
		if HasTag(bodypart, "resurrected") then
			bodyState.oxLevel = 100
			
			dead = false
			bodyState.overall = "healthy"	
			RemoveTag(Torso, "dead")
			deadtim = 0
			drowntim = 0
			RemoveTag(bodypart, "resurrected")
			entirelystop = false
		end
	end
end

end

function GetAimPos(transform)
	ct = bodyparttransform
	if transform then
		ct = transform
	end
    ctrot1, ctrot2, ctrot3 = GetQuatEuler(ct.rot)
    q = QuatEuler(-90, 0, 0)
    ct.rot = q
    local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -150))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
    local direction = VecNormalize(direction)
    QueryRejectBody(bodypart)
    bodypartsB = FindBodies("")
	for i=1,#bodypartsB do
		bodypartB = bodyparts[i]
		QueryRejectBody(bodypartB)
	end 
	shapes = FindShapes("")
	for i=1,#shapes do
		bodypartS = shapes[i]
		QueryRejectShape(bodypartS)
	end 
    local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
    if hit then
        forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
        distance = hitDistance
    end
    return forwardPos, hit, distance
end

function bleedparticles(transform)
	if gorelevel ~= 1 then
		--DebugPrint(gorelevel)
		bodytransform = transform or bodyparttransform
		--spawn sparks
		ParticleType("smoke")
		ParticleColor(0.3, 0.2, 0.2)
		ParticleRadius(0.05, 0.005)
		ParticleAlpha(1000)
		ParticleCollide(1)
		ParticleGravity(-14)
		ParticleSticky(0.5)
		ParticleDrag(0)
		ParticleStretch(1)
		for i=1,bleedintensity/5 do
			local maxIntensity = 5
			SpawnParticle(bodytransform.pos, Vec(math.random(-100,100)/100,math.random(0,math.min(bleedintensity,maxIntensity)*100)/40,math.random(-100,100)/100),10)
		end
	end
end

function PuddleHandleing()
	if bleedbool then
    --DebugCross(GetAimPos())    
    for i=1,#Puddles do
        --DebugPrint(Puddles[i].size)
        if Puddles[i] ~= nil then
        if Puddles[i].amount > 0 and Puddles[i].size < Puddlemaxsize then
            --Paint(Puddles[i].pos, Puddles[i].size, "explosion")
            Puddles[i].amount = Puddles[i].amount - puddleneutspeed/5
            Puddles[i].size = Puddles[i].size + (bleedintensity*GrowSpeed)
			local bleedsize = math.random(0,500)/500
			
			local paintType = "explosion"
			if GetBool("savegame.mod.bloodcolor") then
				paintType = "spraycan"
			end
            Paint(
			Vec(Puddles[i].pos[1] + math.random(-Puddles[i].size * 100,Puddles[i].size * 100)/100, Puddles[i].pos[2], Puddles[i].pos[3] + math.random(-Puddles[i].size * 100,Puddles[i].size * 100)/100),
			math.min(bleedsize/4, blood_intensity/4), paintType, 1)
			--DebugPrint(blood_intensity)
        else
            table.remove(Puddles, i)
            i = i-1 -- <- this is super important since we are in the middle of a for loop and now we remove an item, this changes the whole table so if we would not reduce i by 1 we would jump over an element!
            --- Before [A,B,C,D] and we ar at position 2 so we are here: [A, (B), C , D]
            --- Now, withing the for loop, we remove position 2 so the table looks like this [A, C ,D], but i would still be 2 and in the next for loop iteration it will be 3! so We would then be here: [A, C, (D)] <-- see? We skipped C
        end
    end
end
end
    
    
end

function InsertPuddleToTable(transform)
	if bleedbool then
    local merged = false
    for z=1,#Puddles do
        if Puddles[z] ~= nil then
            pos = Puddles[z].pos
            DistToOtherPuddle = VecLength(VecSub(GetAimPos(transform), pos))
            if DistToOtherPuddle < mergepuddledistance then
                Puddles[z].amount = bleedintensity + Puddles[z].amount
                merged = true
            end
        end
    end
    
    if not merged then

        table.insert(Puddles, {pos=GetAimPos(transform), amount=bleedintensity, size=0})
    end
end
end

function cower()
	if not panic then
	retractjoint1 = sretractjoint
	retractjoint2 = sretractjoint
	retractjoint3 = sretractjoint
	retractjoint4 = sretractjoint
	retractjoint5 = sretractjoint
	end
	if tripped and not dead and not sedated then
		shoulders = FindJoints("shoulder")
		for i=1,#shoulders do
			panick()
			SetJointMotor(shoulders[i], retractjoint1,jointstrength)
		end
		hips = FindJoints("hip")
		for i=1,#hips do
			panick()
			SetJointMotor(hips[i], retractjoint2,jointstrength)
		end
		knees = FindJoints("knee")
		for i=1,#knees do
			panick()
			if not IsJointBroken(hips[i]) then
			SetJointMotor(knees[i], retractjoint3,jointstrength)
			end
		end
		hand1 = FindJoint("hand1")
		hand2 = FindJoint("hand2")
		panick()
		if not IsJointBroken(shoulders[1]) then
		SetJointMotor(hand1, -retractjoint4,jointstrength)
		end
		panick()
		if not IsJointBroken(shoulders[2]) then
		SetJointMotor(hand2, retractjoint5,jointstrength)
		end
		restartjoints = true
	end
end

function restartjointsfunc()
	--if tripped then
	if restartjoints then
	shoulders = FindJoints("shoulder")
	for i=1,#shoulders do
		SetJointMotor(shoulders[i], 0,0)
	end
	hips = FindJoints("hip")
	for i=1,#hips do
		SetJointMotor(hips[i], 0,0)
	end
	knees = FindJoints("knee")
	for i=1,#knees do
		if not IsJointBroken(hips[i]) then
		SetJointMotor(knees[i], 0,0)
	end
	end
	hand1 = FindJoint("hand1")
	hand2 = FindJoint("hand2")
	if not IsJointBroken(shoulders[1]) then
	SetJointMotor(hand1, 0,0)
	end
	if not IsJointBroken(shoulders[2]) then
	SetJointMotor(hand2, 0,0)
	end
	restartjoints = false
end
--end
end

function panick()
	if panic or tripped and not playedsnd then
		PlayLoop(criticalcough, GetBodyTransform(Torso).pos)
	end
	if panic and panictim > 2 then
		if actualpanictim > 0.05 then
			lol = math.random(0,6)
		if lol == 1 then
		retractjoint1 = math.random(-sretractjoint, sretractjoint)
		end
		if lol == 2 then
		retractjoint2 = math.random(-sretractjoint, sretractjoint)
		end
		if lol == 3 then
		retractjoint3 = math.random(-sretractjoint, sretractjoint)
		end
		if lol == 4 then
		retractjoint4 = math.random(-sretractjoint, sretractjoint)
		end
		if lol == 5 then
		retractjoint5 = math.random(-sretractjoint, sretractjoint)
		end
		if lol == 6 then
			jawjointss = FindJoints("jaw")
			for i=1,#jawjointss do
				SetJointMotor(jawjointss[i], math.random(-15,15), 200)
			end
		end
		actualpanictim = 0

	end
	end
	end

	function GetAimPossit()
   local ct = GetPlayerCameraTransform()
   local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -200))
   local direction = VecSub(forwardPos, ct.pos)
   local distance = VecLength(direction)
   local direction = VecNormalize(direction)
   QueryRejectBody(sb)
   local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
   if hit then
      forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
      distance = hitDistance
   end
   return forwardPos, hit, distance
end

function sit()
	if sitting and not panic and not inposition then
		inpostim = inpostim + 0.1
		if inpostim > 2 then
			inposition = true
			inpostim = 0
		end
		--DebugPrint(inpostim)
		shoulders = FindJoints("shoulder")
	for i=1,#shoulders do
		panick()
		--SetJointMotor(shoulders[i], retractjoint1,jointstrength)
	end
	hips = FindJoints("hip")
	for i=1,#hips do
		panick()
		SetJointMotor(hips[i], retractjoint2/15)
	end
	knees = FindJoints("knee")
	for i=1,#knees do
		panick()
		if not IsJointBroken(hips[i]) then
		SetJointMotor(knees[i], retractjoint3/15)
		end
	end
	hand1 = FindJoint("hand1")
	hand2 = FindJoint("hand2")
	panick()
	if not IsJointBroken(shoulders[1]) then
	--SetJointMotor(hand1, -retractjoint4,jointstrength)
	end
	panick()
	if not IsJointBroken(shoulders[2]) then
	--SetJointMotor(hand2, retractjoint5,jointstrength)
	end
	end
end

local lastPartLooked = 0

function CheckHealthUi()

	local lookingAtMe = GetInt("health.ui.target.body") ~= nil and RagdollBody[GetInt("health.ui.target.body")] ~= nil	
	
	
	if InputPressed("h") then 			
		if lookingAtMe and not MyHealthUiIsActive then
			MyHealthUiIsActive = true
			SetInt("health.ui.active.body", Torso)
			SetBool("health.ui.shown", true)
		else
			MyHealthUiIsActive = false			
			if GetInt("health.ui.active.body") == Torso then
				SetBool("health.ui.shown", false)
			end
		end							
	end	
	
	if not lookingAtMe and GetInt("health.ui.active.body") ~= Torso then
		MyHealthUiIsActive = false		
	end
	
	if lookingAtMe and GetBool("health.ui.shown") then
		MyHealthUiIsActive = true
		SetInt("health.ui.active.bodypart", GetInt("health.ui.target.body"))
	end
	
	if MyHealthUiIsActive then
		SetInt("health.ui.active.body", Torso)
		bodyState.indBloodValue = GetTagValue(GetInt("health.ui.active.bodypart"),"bloodLevel")
		bodyState.lookingAtPart = GetInt("health.ui.active.bodypart")
		ShowUiHealthOverlay()	
	else
		HideUiHealthOverlay()	
	end	
end